﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Q_Learning
{
	using Pair = KeyValuePair<int, bool>;
	public class AI
	{
		public Random rand;
		private static int[,] Line =
		{
			{0,1,2},{3,4,5},{6,7,8},{0,3,6},{1,4,7},{2,5,8},{0,4,8},{2,4,6}
		};
		/// <summary>コンストラクタ</summary>
		public AI()
		{
			rand = new Random(1);
		}
		/// <summary>
		/// 1:先手勝ち,2:後手勝ち,3:引分,0:o.w.
		/// </summary>
		public static int Check(Status s)
		{
			int[] ii = new int[3];
			for (int i = 0; i < 8; i++)
			{
				ii[1] = ii[2] = 0;
				for (int j = 0; j < 3; ++j) ++ii[(int)s[Line[i, j]]];
				if (ii[1] == 3) return 1;
				if (ii[2] == 3) return 2;
			}
			return ii[0] == 0 ? 3 : 0;
		}
		public Pair NextAction(Status s, bool bFirst)
		{
			List<int> lst1 = new List<int>(); // 負ける場合
			List<int> lst2 = new List<int>(); // リーチできる場合
			// 勝てる場合
			for (int i = 0; i < 8; i++)
			{
				int fr = 0, sc = 0, k1 = 0, k2 = 0, l;
				for (int j = 0; j < 3; ++j)
				{
					EStatus es = s[l = Line[i, j]];
					if (es == EStatus.First) ++fr;
					else if (es == EStatus.Second) ++sc;
					else { k2 = k1; k1 = l; }
				}
				if (bFirst)
				{
					if (fr == 2 && sc == 0) return PairValue(bFirst, k1, true);
					else if (fr == 0 && sc == 2) lst1.Add(k1);
					else if (fr == 1 && sc == 0) { lst2.Add(k1); lst2.Add(k2); }
				}
				else
				{
					if (sc == 2 && fr == 0) return PairValue(bFirst, k1, true);
					else if (sc == 0 && fr == 2) lst1.Add(k1);
					else if (sc == 1 && fr == 0) { lst2.Add(k1); lst2.Add(k2); }
				}
			}
			// 負ける場合
			if (lst1.Count > 0)
				return PairValue(bFirst, lst1[0], false);
			// リーチできない場合
			if (lst2.Count == 0)
			{
				for (int i = 0; i < 9; ++i)
				{
					EStatus es = s[i];
					if (es == EStatus.None) lst2.Add(i);
				}
			}
			if (lst2.Count > 0)
				return PairValue(bFirst, lst2[rand.Next(lst2.Count)], false);
			return new Pair(0, false);
		}
		public Pair PairValue(bool bFirst, int i, bool bEnd)
		{
			return new Pair(bFirst ? i + 1 : -i - 1, bEnd);
		}
	}
}
