﻿using Microsoft.VisualStudio.DebuggerVisualizers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Drawing;
using System.Windows.Forms;

namespace Q_Learning
{
	/// <summary>
	/// SomeType のビジュアライザです。  
	/// </summary>
	public class StatusVisualizer : DialogDebuggerVisualizer
	{
		protected override void Show(IDialogVisualizerService windowService, IVisualizerObjectProvider objectProvider)
		{
			using (Form dlg = new Form())
			{
				Ban ban = new Ban();
				ban.Location = new Point(60, 60);
				dlg.Controls.Add(ban);
				ban.Status = (Status)objectProvider.GetObject();
				windowService.ShowDialog(dlg);
			}
		}

		// TODO: ビジュアライザをテストするために、次のコードをユーザーのコードに追加します:
		// 
		//    StatusVisualizer.TestShowVisualizer(new SomeType());
		// 
		/// <summary>
		/// デバッガの外部にホストすることにより、ビジュアライザをテストします。
		/// </summary>
		/// <param name="objectToVisualize">ビジュアライザに表示するオブジェクトです。</param>
		public static void TestShowVisualizer(object objectToVisualize)
		{
			VisualizerDevelopmentHost visualizerHost = new VisualizerDevelopmentHost(objectToVisualize, typeof(StatusVisualizer));
			visualizerHost.ShowVisualizer();
		}
	}
}
